VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4995
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7320
   LinkTopic       =   "Form1"
   ScaleHeight     =   4995
   ScaleWidth      =   7320
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   6000
      TabIndex        =   20
      Top             =   4080
      Width           =   615
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   4920
      TabIndex        =   19
      Top             =   4080
      Width           =   735
   End
   Begin VB.TextBox txtWdRange 
      Height          =   285
      Left            =   3120
      TabIndex        =   13
      Text            =   "45"
      Top             =   3480
      Width           =   1335
   End
   Begin VB.TextBox txtWsMax 
      Height          =   285
      Left            =   4920
      TabIndex        =   12
      Text            =   "3.0"
      Top             =   3000
      Width           =   1575
   End
   Begin VB.TextBox txtWsMin 
      Height          =   285
      Left            =   3120
      TabIndex        =   11
      Text            =   "0.5"
      Top             =   3000
      Width           =   1335
   End
   Begin VB.TextBox txtRecepY 
      Height          =   285
      Left            =   4920
      TabIndex        =   5
      Text            =   "0"
      Top             =   1920
      Width           =   1455
   End
   Begin VB.TextBox txtRecepX 
      Height          =   285
      Left            =   3000
      TabIndex        =   4
      Text            =   "0"
      Top             =   1920
      Width           =   1455
   End
   Begin VB.TextBox txtSourceY 
      Height          =   285
      Left            =   4920
      TabIndex        =   3
      Text            =   "0"
      Top             =   1440
      Width           =   1455
   End
   Begin VB.TextBox txtSourceX 
      Height          =   285
      Left            =   3000
      TabIndex        =   2
      Text            =   "0"
      Top             =   1440
      Width           =   1455
   End
   Begin VB.TextBox txtMetFile 
      Height          =   285
      Left            =   1680
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   360
      Width           =   4815
   End
   Begin VB.CommandButton cmdMetFile 
      Height          =   375
      Left            =   1200
      Picture         =   "NEWA 23-13-2011.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   360
      Width           =   375
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   6720
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "*.aus *.AUS *.csv *.CSV *.isc *.ISC"
      FontName        =   "Arial"
   End
   Begin VB.Frame Frame1 
      Caption         =   "Source and receiver information"
      Height          =   1455
      Left            =   480
      TabIndex        =   6
      Top             =   960
      Width           =   6375
      Begin VB.Label Label4 
         Caption         =   "Northing (m)"
         Height          =   255
         Left            =   4560
         TabIndex        =   10
         Top             =   240
         Width           =   1095
      End
      Begin VB.Label Label2 
         Caption         =   "Easting (m)"
         Height          =   255
         Left            =   2640
         TabIndex        =   9
         Top             =   240
         Width           =   1095
      End
      Begin VB.Label Label1 
         Caption         =   "Receiver location"
         Height          =   255
         Left            =   840
         TabIndex        =   8
         Top             =   960
         Width           =   1455
      End
      Begin VB.Label Label3 
         Caption         =   "Noise source location"
         Height          =   255
         Left            =   600
         TabIndex        =   7
         Top             =   480
         Width           =   1815
      End
   End
   Begin VB.Label Label9 
      Caption         =   "degrees"
      Height          =   255
      Left            =   4920
      TabIndex        =   18
      Top             =   3480
      Width           =   1215
   End
   Begin VB.Label Label8 
      Caption         =   "Angle of wind on either side of the line joining the source and receiver"
      Height          =   615
      Left            =   240
      TabIndex        =   17
      Top             =   3480
      Width           =   2415
   End
   Begin VB.Label Label7 
      Caption         =   "Max"
      Height          =   255
      Left            =   4920
      TabIndex        =   16
      Top             =   2760
      Width           =   735
   End
   Begin VB.Label Label6 
      Caption         =   "Min"
      Height          =   255
      Left            =   3120
      TabIndex        =   15
      Top             =   2760
      Width           =   735
   End
   Begin VB.Label Label5 
      Caption         =   "Wind speed range to include in the analysis (m/s) (see user notes)"
      Height          =   495
      Left            =   240
      TabIndex        =   14
      Top             =   3000
      Width           =   2655
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' This program has been developed by Nigel Holmes for the Office of Environment and Heritage.  Its purpose
' is to assist people in using readily available nmeteorological data to determine if meteorological
' influences are a feature of an area that should be taken into account in assessing noise impacts for a proposal
' in a particular area.  The procedures are consistent with the requirements of the INP for assessing the effects of wind.
' Date 28 September 2011.

Private Sub cmdMetFile_Click()
On Error GoTo errhandler
  
CommonDialog1.FileName = txtMetFile.Text
CommonDialog1.Filter = "All Recognised Files|*.aus;*.isc;*.csv|ISCST3 Met Files (*.isc)|*.isc|AUSPLUME Met Files (*.aus)|*.aus|CSV Met Files (*.csv)|*.csv"
CommonDialog1.ShowOpen
txtMetFile.Text = CommonDialog1.FileName

errhandler:
End Sub

Private Sub cmdOK_Click()
On Error GoTo errhandler

'Check GUI inputs
If txtMetFile.Text = "" Then
    MsgBox "Please select meteorological data file", vbExclamation, Me.Caption
    cmdMetFile.SetFocus
    Exit Sub
End If
If IsNumeric(txtSourceX.Text) = False Then
    MsgBox "Invalid source easting specified", vbExclamation, Me.Caption
    txtSourceX.SetFocus
    Exit Sub
End If
If IsNumeric(txtSourceY.Text) = False Then
    MsgBox "Invalid source northing specified", vbExclamation, Me.Caption
    txtSourceY.SetFocus
    Exit Sub
End If
If IsNumeric(txtRecepX.Text) = False Then
    MsgBox "Invalid receptor easting specified", vbExclamation, Me.Caption
    txtRecepX.SetFocus
    Exit Sub
End If
If IsNumeric(txtRecepY.Text) = False Then
    MsgBox "Invalid receptor northing specified", vbExclamation, Me.Caption
    txtRecepY.SetFocus
    Exit Sub
End If

If IsNumeric(txtWsMin.Text) = False Then
    MsgBox "Invalid minimum wind speed specified", vbExclamation, Me.Caption
    txtWsMin.SetFocus
    Exit Sub
End If
If IsNumeric(txtWsMax.Text) = False Then
    MsgBox "Invalid maximum wind speed specified", vbExclamation, Me.Caption
    txtWsMax.SetFocus
    Exit Sub
End If
If IsNumeric(txtWdRange.Text) = False Then
    MsgBox "Invalid wind direction range specified", vbExclamation, Me.Caption
    txtWdRange.SetFocus
    Exit Sub
End If

'Declare variables
  Dim sData As String, dWD As Double, dWS As Double
  Dim WindUnder3(4, 3) As Double, AllWinds(4, 3) As Double
  Dim dAngle As Double, dWindComponent As Double, LowerTestAngle As Double
  Dim UpperTestAngle As Double, dWsMin As Double, dWsMax As Double, dWdRange As Double
  Dim dWDFlow As Double, MetType As String, dDistance As Double
  Dim iSeason As Integer, iTime As Integer, iTimeIndex As Integer, iSeasonIndex As Integer
  Dim iNumberOfRecords As Long, ihour As Integer, imonth As Integer, iyear As Double, iday As Integer
  Dim sSeason(4) As String
  Dim imonthtest As String
  
'Determine met file type
    Select Case Right(txtMetFile.Text, 3)
    Case "AUS", "aus"
        MetType = "AUS"
    Case "ISC", "isc"
        MetType = "ISC"
    Case "CSV", "csv"
        MetType = "CSV"
    Case Else
        MsgBox "Unidentified meteorological data file type." & vbCrLf & _
            "AUSPLUME (*.aus), ISCST3 (*.isc) or CSV (*.csv) file types accepted only.", vbExclamation, Me.Caption
            Exit Sub
    End Select

' User error: x1 = x2 and y1 = y2
    If Val(txtRecepY.Text) = Val(txtSourceY.Text) And Val(txtRecepX.Text) = Val(txtSourceX.Text) Then
        MsgBox "Warning Source and Receiver have the same coordinates.", vbExclamation, Me.Caption
    'Exit Sub
    End If

'Determine angle from source to receptor
'in degree from true north
    If Val(txtRecepX.Text) - Val(txtSourceX.Text) <> 0 Then
        dAngle = 180 / 3.141593 * (Atn((Val(txtRecepY.Text) - Val(txtSourceY.Text)) / (Val(txtRecepX.Text) - Val(txtSourceX.Text))))
        dDistance = Sqr((Val(txtRecepX.Text) - Val(txtSourceX.Text)) ^ 2 + (Val(txtRecepY.Text) - Val(txtSourceY.Text)) ^ 2)
    End If

    If Val(txtRecepY.Text) > Val(txtSourceY.Text) _
        And Val(txtRecepX.Text) > Val(txtSourceX.Text) Then
        dAngle = 90 - dAngle
    ElseIf Val(txtRecepY.Text) < Val(txtSourceY.Text) _
        And Val(txtRecepX.Text) > Val(txtSourceX.Text) Then
        dAngle = 90 + (-1) * dAngle
    ElseIf Val(txtRecepY.Text) < Val(txtSourceY.Text) _
        And Val(txtRecepX.Text) < Val(txtSourceX.Text) Then
        dAngle = 270 - dAngle
    ElseIf Val(txtRecepY.Text) > Val(txtSourceY.Text) _
        And Val(txtRecepX.Text) < Val(txtSourceX.Text) Then
        dAngle = 270 + (-1) * dAngle
    ElseIf Val(txtRecepY.Text) = Val(txtSourceY.Text) _
        And Val(txtRecepX.Text) > Val(txtSourceX.Text) Then
        dAngle = 90
    ElseIf Val(txtRecepY.Text) = Val(txtSourceY.Text) _
        And Val(txtRecepX.Text) < Val(txtSourceX.Text) Then
        dAngle = 270
    ElseIf Val(txtRecepY.Text) > Val(txtSourceY.Text) _
        And Val(txtRecepX.Text) = Val(txtSourceX.Text) Then
        dAngle = 0
    ElseIf Val(txtRecepY.Text) < Val(txtSourceY.Text) _
        And Val(txtRecepX.Text) = Val(txtSourceX.Text) Then
        dAngle = 180
    End If
    

'Read met file
   Open txtMetFile.Text For Input As #1

'Read the headerHeader
   Line Input #1, sData

'Set record counter to 0
   iNumberOfRecords = 0
   
'Assign user selected wind speed and wind angle ranges to variables

   dWsMin = Val(txtWsMin.Text)
   dWsMax = Val(txtWsMax.Text)
   dWdRange = Val(txtWdRange.Text)

'Loop through data
'frmMain.SBar.Panels(3).Text = "Reading..."
     
     Do Until EOF(1)

'Get wind speed and wind flow from met file as well as other data
    Select Case MetType
    
    Case "AUS"
        Line Input #1, sData
'Count how many records are read
        iNumberOfRecords = iNumberOfRecords + 1
        dWS = Val(Mid(sData, 13, 4))
        dWDFlow = Val(Mid(sData, 18, 3)) + 180
        If dWDFlow > 360 Then dWDFlow = dWDFlow - 360
'Determine month and hour for AUS files so that season and time of day can be determined
        imonthtest = CInt(Mid(sData, 3, 2))
        ihour = CInt(Mid(sData, 7, 2))
        
'If iNumberOfRecords > 3 Then Stop
    
    Case "ISC"
        Line Input #1, sData
'Count how many records are read
        iNumberOfRecords = iNumberOfRecords + 1
        dWS = Val(Mid(sData, 20, 5))
        dWDFlow = Val(Mid(sData, 10, 5))
'Determine month and hour for ISC files so the season and time of day can be determined
        imonthtest = CInt(Mid(sData, 3, 2))
        ihour = CInt(Mid(sData, 7, 2))
    
    Case "CSV"
'Count how many records are read
        iNumberOfRecords = iNumberOfRecords + 1
        If iNumberOfRecords < 1 Then Line Input #1, sData
        Input #1, iyear, imonthtest, iday, ihour, dWS, dWDFlow
        dWDFlow = dWDFlow + 180
        If dWDFlow > 360 Then dWDFlow = dWDFlow - 360
       
       'If CheckCount1 = 32766 Then Stop
       
       'Determine month for CSV files so the season can be determined
        imonthtest = CInt(imonthtest)
        ihour = CInt(ihour)
'If iNumberOfRecords > 100 Then Stop
    End Select
       
'Determine wind speed component blowing from source to receptor
    dWindComponent = dWS * Cos((dWDFlow - dAngle) / 57.296)
   
    Select Case imonthtest
    
    Case 1, 2, 12  'Summer
        iSeason = 1
    Case 3, 4, 5 'Autumn
        iSeason = 2
    Case 6, 7, 8 'Winter
        iSeason = 3
    Case 9, 10, 11 'Spring
        iSeason = 4
    End Select

'Determine hour (day, evening or night)
    Select Case ihour
    Case 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18 'Day
        iTime = 1
    Case 19, 20, 21, 22 'Evening
        iTime = 2
    Case 1, 2, 3, 4, 5, 6, 7, 23, 24, 0  'Night
        iTime = 3
    End Select

'Add number of hours to arrays

'First make all angles positive clockwise from north

    If dAngle - Val(txtWdRange) < 0 Then
       LowerTestAngle = 0 'dAngle - Val(txtWdRange) + 360
       UpperTestAngle = dAngle + Val(txtWdRange) + Abs(dAngle - Val(txtWdRange))
       dWDFlow = (dWDFlow + Abs(dAngle - Val(txtWdRange)))
       If dWDFlow > 360 Then dWDFlow = dWDFlow - 360
       CheckCount1 = CheckCount1 + 1  'diagnostic line only
    Else
       LowerTestAngle = dAngle - Val(txtWdRange)
       UpperTestAngle = dAngle + Val(txtWdRange)
       CheckCount2 = CheckCount2 + 1  'diagnostic line only
    End If
    
' Count the number of hours of wind in each season and day/evening/night time period.
    AllWinds(iSeason, iTime) = AllWinds(iSeason, iTime) + 1
       
       If ((dWS > dWsMin) And (dWindComponent < dWsMax) And (dWindComponent > 0) And (dWDFlow > LowerTestAngle) And (dWDFlow < UpperTestAngle)) Then
'the wind condition is INSIDE the wind speed and wind direction range specified by the user
       WindUnder3(iSeason, iTime) = WindUnder3(iSeason, iTime) + 1
       CheckCount3 = CheckCount3 + 1  'diagnostic line only
    Else
'the wind condition is OUTSIDE the wind speed or wind direction range specified by the user
       CheckCount4 = CheckCount4 + 1  'diagnostic line only
    End If
Loop
Close #1

'frmMain.SBar.Panels(3).Text = ""

'Set season names
sSeason(1) = "Summer": sSeason(2) = "Autumn"
sSeason(3) = "Winter": sSeason(4) = "Spring"

'Write to output file
Open App.Path & "\Results.txt" For Output As #2
Print #2, " -------------------------------"
Print #2, "  NOISE WIND COMPONENT ANALYSIS"
Print #2, " -------------------------------"
Print #2, ""
Print #2, "Meteorological data file    : " & txtMetFile.Text
Print #2, "Noise source location       : " & txtSourceX.Text & ", " & txtSourceY.Text
Print #2, "Receiver location           : " & txtRecepX.Text & ", " & txtRecepY.Text
Print #2, "Source to receiver angle    : " & Format(dAngle, "0") & " degrees clockwise from north"
Print #2, "Source to receiver distance : " & Format(dDistance, "0.0") & " in same units as coordinates"
Print #2, "Number of records read      : " & Format(iNumberOfRecords, "0")
Print #2, ""
Print #2, ""
Print #2, "RESULTS: (as a percentage)"
Print #2, ""
Print #2, "Percentage of winds speed records in the range > " & Format(dWsMin, "0.0"); " and < " & Format(dWsMax, "0.0"); " m/s"
Print #2, "and direction records in the range " & Format(dAngle, "0"); " degrees plus and minus " & Format(dWdRange, "0")
Print #2, ""
Print #2, "Season    Day   Evening  Night"
For iSeasonIndex = 1 To 4
    Print #2, sSeason(iSeasonIndex);
    For iTimeIndex = 1 To 3
    
    If AllWinds(iSeasonIndex, iTimeIndex) > 0.0000001 Then
       Print #2, "   " & Format((WindUnder3(iSeasonIndex, iTimeIndex) / AllWinds(iSeasonIndex, iTimeIndex) * 100), "000.0");
    Else
       Print #2, "   " & Format((0# * 100), "000.0");
    End If
    
    Next iTimeIndex
    Print #2, ""
Next iSeasonIndex
Print #2, ""
Print #2, ""
Print #2, "RESULTS: (as counts)"
Print #2, ""
Print #2, "Number of winds speed records in the range > " & Format(dWsMin, "0.0"); " and < " & Format(dWsMax, "0.0"); " m/s"
Print #2, "and direction records in the range " & Format(dAngle, "0"); " degrees plus and minus " & Format(dWdRange, "0")
Print #2, ""
Print #2, "Season    Day    Evening  Night"
For iSeasonIndex = 1 To 4
    Print #2, sSeason(iSeasonIndex);
    For iTimeIndex = 1 To 3
    Print #2, "    " & Format((WindUnder3(iSeasonIndex, iTimeIndex)), "0000");
    Next iTimeIndex
    Print #2, ""
Next iSeasonIndex
Print #2, ""

Close #2

'Me.Hide

'Show the summary report
'Call modFiles.modFileLoad(App.Path & "\report.dat")
'frmMain.ActiveForm.Caption = "Report: Utilities > Noise Wind Component Analysis"

'errhandler:
'frmMain.SBar.Panels(3).Text = ""
'Close #1, #2
'MsgBox "Error encountered" & vbCrLf & Err.Description, vbCritical, "Error"
'End Sub

'Display result in Notepad
Open App.Path & "\NEWA.bat" For Output As #3
Print #3, "Start Notepad " & App.Path & "\Results.txt"
Print #3, "exit"
Close #3
Shell App.Path & "\NEWA.bat", vbHide

Exit Sub

errhandler:
Close #1, #2
MsgBox "Error encountered" & vbCrLf & Err.Description, vbCritical, "Error"
End Sub

Private Sub cmdExit_Click()
'Unload form and exit sub
 Unload Me
End
End Sub
